Name:           dansguardian
Version:        2.12.0.3
Release:        3%{?dist}alfa
Summary:        Content filtering web proxy
Summary(de):    Contentfilter-Proxy
Packager : Django <django@mailserver.guru>
Distribution: CentOS 7

Group:          System Environment/Daemons
# upstream dual-licenses this with GPLv2+ and an own license
# for us GPLv2+ applies as stated on http://dansguardian.org/?page=copyright2
# citation:
#    freely (no cost) downloadable from this site for general purpose unix
#    distributions like FreeBSD, Debian, Fedora, Ubuntu, etc
License:        GPLv2+
URL:            http://www.dansguardian.org/
Source0:        http://dansguardian.org/downloads/2/Stable/%{name}-%{version}.tar.bz2
Source1:        dansguardian.service
Source2:        dansguardian.httpd
Source3:        dansguardian.logrotate
# ClamAV integration
Source4:        dansguardian-clamd.conf
Source5:        dansguardian-clamd.service
Source6:        dansguardian-clamd.sysconfig
Patch0:         dansguardian-polish.patch
Patch1:         dansguardian-maxuploadsize.patch
# Adds support for ClamAV > 0.95
Patch2:         dansguardian-clamav095.patch
# Fix some typos ;) (Bug #515363)
Patch3:         dansguardian-must-be-successful.patch
# Remove check for clamav version
Patch4:         dansguardian-2.10.1.1-Do-no-check-for-clamav-version.patch
# g++-4.7 does not provide sizeof() by default
Patch5:         dansguardian-2.10.1.1-Include-stddef.h-for-offsetof.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:   clamav-devel pcre-devel zlib-devel
BuildRequires:   pkgconfig
# For Do-no-check-for-clamav-version patch
BuildRequires:   autoconf
# For %%_unitdir
BuildRequires:   systemd-units
Requires(pre):   shadow-utils
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
# For triggerun
Requires(post): systemd-sysv
Requires:       clamav-server


%description
DansGuardian filters the content of pages based on many methods including
phrase matching, PICS filtering and URL filtering. It does not purely filter
based on a banned list of sites.

It provides real-time virus scanning capabilities for content access.

DansGuardian is designed to be completely flexible and allows you to tailor the
filtering to your exact needs. It can be as draconian or as unobstructive as
you want. The default settings are geared towards what a primary school might
want but DansGuardian puts you in control of what you want to block.

DansGuardian requires squid or another similar caching proxy server on your
local network.

%description -l de
DansGuardian filtert den Content einer Webseite basierend auf verschiedenen
Methoden wie beispielsweise Wortfilter, PICS filtering und URL filtering. Es
handelt sich also um ein echtes Content filtering anstatt einfacher Blacklists.

Außerdem bietet DansGuardian die Möglichkeit einen Virenfilter einzubinden.

DansGuardian wurde darauf ausgelegt so flexibel wie möglich zu sein und
erlaubt es die Filterregeln exakt auf die eigenen Bedürfnisse anzupassen.
Vorgegeben sind Einstellungen die dem Bedarf einer Grundschule entsprechen.

DansGuardian benötigt squid oder einen ähnlichen Caching-Proxy-Server im
lokalen Netzwerk.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
#%patch2 -p1
#%patch3 -p1
#%patch4 -p1
#%patch5 -p1
##############autoconf

%build
%configure \
   --enable-clamd \
   --enable-avastd \
   --enable-icap \
   --enable-kavd \
   --enable-commandline \
   --enable-fancydm \
   --enable-trickledm \
   --enable-email \
   --enable-ntlm \
   --enable-orig-ip \
   --with-proxyuser=dansguardian \
   --with-proxygroup=dansguardian

make
#make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
install -Dpm 644 %{SOURCE3} \
    $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/%{name}
# delete the other scripts since they are of no use for Fedora users
rm -rf $RPM_BUILD_ROOT%{_datadir}/%{name}/scripts
chmod 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}.pl

# install init script and httpd config
install -Dpm 644 %{SOURCE1} $RPM_BUILD_ROOT%{_unitdir}/%{name}.service
install -Dp -m0644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/%{name}.conf

# we'll install this later within %doc
rm -rf $RPM_BUILD_ROOT%{_datadir}/doc/%{name}

# create the log dir
install -dm 755 $RPM_BUILD_ROOT%{_localstatedir}/log/%{name}

# for clamav integration
install -dm 700 $RPM_BUILD_ROOT%{_localstatedir}/run/%{name}
touch $RPM_BUILD_ROOT%{_localstatedir}/run/%{name}/clamd.sock
( cd $RPM_BUILD_ROOT%{_sbindir} && ln -s clamd clamd.%{name} )
install -m644 %{SOURCE5} $RPM_BUILD_ROOT%{_unitdir}/clamd.%{name}.service
install -dm755 $RPM_BUILD_ROOT%{_sysconfdir}/clamd.d
install -m644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/clamd.d/%{name}.conf
install -dm755 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m644 %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/clamd.%{name}

%clean
rm -rf $RPM_BUILD_ROOT


%pre
getent group %{name} >/dev/null || groupadd -r %{name}
getent passwd %{name} >/dev/null || \
useradd -r -g %{name} -d %{_datadir}/%{name} -s /sbin/nologin \
   -c "DansGuardian web content filter" %{name}
exit 0

# in the first release we put some user-editable files inside the datadir. doh!
# if they are still there we migrate them over to their new home in the
# sysconfdir.
if [ "$1" -gt 1 ] ; then
    if [ -e %{_datadir}/%{name}/lists ] ; then
        mv -f %{_datadir}/%{name}/lists %{_sysconfdir}/%{name}
    fi
fi

%post
if [ $1 -eq 1 ] ; then 
    # Initial installation 
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%preun
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable dansguardian.service > /dev/null 2>&1 || :
    /bin/systemctl stop dansguardian.service > /dev/null 2>&1 || :
    /bin/systemctl --no-reload disable clamd.dansguardian.service > /dev/null 2>&1 || :
    /bin/systemctl stop clamd.dansguardian.service > /dev/null 2>&1 || :
fi


%postun
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
    # Package upgrade, not uninstall
    /bin/systemctl try-restart clamd.dansguardian.service >/dev/null 2>&1 || :
    /bin/systemctl try-restart dansguardian.service >/dev/null 2>&1 || :
fi

%triggerun -- dansguardian < 2.10.1.1-9
# Save the current service runlevel info
# User must manually run systemd-sysv-convert --apply dansguardian
# and systemd-sysv-convert --apply clamd.dansguardian
# to migrate them to systemd targets
/usr/bin/systemd-sysv-convert --save dansguardian >/dev/null 2>&1 ||:
/usr/bin/systemd-sysv-convert --save clamd.dansguardian >/dev/null 2>&1 ||:

# Run these because the SysV package being removed won't do them
/sbin/chkconfig --del dansguardian >/dev/null 2>&1 || :
/sbin/chkconfig --del clamd.dansguardian >/dev/null 2>&1 || :
/bin/systemctl try-restart clamd.dansguardian.service >/dev/null 2>&1 || :
/bin/systemctl try-restart dansguardian.service >/dev/null 2>&1 || :


%files
%defattr(-,root,root,-)
%doc COPYING INSTALL README UPGRADING
%doc doc/AuthPlugins doc/ContentScanners doc/DownloadManagers doc/FAQ
%doc doc/FAQ.html doc/Plugins
%doc %{_mandir}/man8/%{name}.8.gz
%{_sbindir}/%{name}
%attr(-,%{name},%{name}) %{_datadir}/%{name}
%{_unitdir}/%{name}.service
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/%{name}*.conf
%dir %{_sysconfdir}/%{name}/authplugins
%config(noreplace) %{_sysconfdir}/%{name}/authplugins/*
%dir %{_sysconfdir}/%{name}/contentscanners
%config(noreplace) %{_sysconfdir}/%{name}/contentscanners/*
%dir %{_sysconfdir}/%{name}/downloadmanagers
%config(noreplace) %{_sysconfdir}/%{name}/downloadmanagers/*
%dir %{_sysconfdir}/%{name}/lists
%config(noreplace) %{_sysconfdir}/%{name}/lists/*
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%attr(755,%{name},%{name}) %dir %{_localstatedir}/log/%{name}
%attr(700,%{name},%{name}) %dir %{_localstatedir}/run/%{name}
%{_sbindir}/clamd.%{name}
%{_unitdir}/clamd.%{name}.service
%ghost %{_localstatedir}/run/%{name}/clamd.sock
%config(noreplace) %{_sysconfdir}/clamd.d/%{name}.conf
%config(noreplace) %{_sysconfdir}/sysconfig/clamd.%{name}


%changelog
* Tue Jan 20 2015 Django <django@mailserver.guru> 2.12.0.3-1
- Initial build for CentOS 7

